@echo off
COLOR 81
:MENU
cls
@echo *****************************************
@echo * SAMSUNG N9005 EFS And ModemST Backup  *
@echo *****************************************
@echo *   Made By NimaGL2 Thanks to A.S._id   *
@echo *    A.S._id      *     Genius.Lizard2  *
@echo * To Use get ROOT                       *
@echo * connect to the USB debugging mode     *
@echo *                                       *
@echo * This Script will package BACKUP EFS   *
@echo * for flashing via Oidin.               *
@echo *****N9005 EFS Folder Beckup/Restore*****
@echo * Options:                              *
@echo * 1. BACKUP EFS                         *
@echo * 2. ODIN RESTORE                       *
@echo * 3. DD RESTORE                         *
@echo * 4. TAR.GZ_RESTORE                     *
@echo ***Qualcomm ModemST 1,2 Beckup/Restore***
@echo * 5. DD Backup  (Qualcomm) (N9005)      *
@echo * 6. DD RESTORE (Qualcomm) (N9005)      *
@echo * 7. Exit********************************
@echo *****************************************
CHOICE /C:1234567 /N /M "Please Select Option:"
IF ERRORLEVEL 7 GOTO EXIT
IF ERRORLEVEL 6 GOTO STR
IF ERRORLEVEL 5 GOTO STB
IF ERRORLEVEL 4 GOTO TAR.GZ_RESTORE
IF ERRORLEVEL 3 GOTO DD_RESTORE
IF ERRORLEVEL 2 GOTO ODIN_RESTORE
IF ERRORLEVEL 1 GOTO BACKUP

:STB
CLS
@echo *****************************************
@echo *        BACKUP MODEMST 1 and 2         *
@echo *****************************************
CHOICE /C YN /M "WARNING: Do you wish to Continue? (This will Backup Qualcomm Modemst 1&2 via command dd)"
IF ERRORLEVEL 2 GOTO MENU
@echo --- STARTING ----
@echo --- WAITING FOR DEVICE
bin\adb wait-for-device
@echo --- Backup Modemst images ---
bin\adb shell "echo | getprop > /sdcard/getprop.txt"
bin\adb pull /storage/sdcard0/getprop.txt
bin\adb shell "echo | getprop ril.product_code > /sdcard/version.txt ; getprop gsm.version.baseband >> /sdcard/version.txt ; getprop ril.serialnumber >> /sdcard/version.txt"
bin\adb pull /sdcard/version.txt
setlocal enabledelayedexpansion
for /f "tokens=*" %%a in (version.txt) do set "var=!var!%%a_"
echo %var%
bin\adb shell su -c "dd if=dev/block/mmcblk0p12 of=/sdcard/%var%MST1.raw.img"
bin\adb shell su -c "dd if=dev/block/mmcblk0p13 of=/sdcard/%var%MST2.raw.img"
bin\adb pull /sdcard/%var%MST1.raw.img
bin\adb pull /sdcard/%var%MST2.raw.img
bin\7za.exe a MST_%var%MST.zip %var%MST1.raw.img %var%MST2.raw.img getprop.txt
del *.img *.txt *.md5
@echo -
@echo -
@echo Finished. Output file is MST_%var%MST BACKUP
) ELSE ( @echo "ERROR: PACKAGING does not exist" )
pause
goto MENU

:STR
CLS
@echo *****************************************
@echo *       RESTORE MODEMST 1 and 2         *
@echo *****************************************
CHOICE /C YN /M "WARNING: Do you wish to Continue? (This will Restore Qualcomm Modemst 1&2 via command dd)"
IF ERRORLEVEL 2 GOTO MENU
bin\7za.exe e MST_*MST.zip *MST1.raw.img *MST2.raw.img
@echo --- STARTING ----
@echo --- WAITING FOR DEVICE
bin\adb wait-for-device
@echo --- Restore Modemst images ---
bin\adb push *MST1.raw.img /sdcard/MST1.raw.img
bin\adb push *MST2.raw.img /sdcard/MST2.raw.img
bin\adb shell su -c "dd if=/sdcard/MST1.raw.img of=/dev/block/mmcblk0p12 bs=4096"
bin\adb shell su -c "dd if=/sdcard/MST2.raw.img of=/dev/block/mmcblk0p13 bs=4096"
del *.img
pause
goto MENU

:BACKUP
CLS
@echo *****************************************
@echo *              BACKUP EFS               *
@echo *****************************************
CHOICE /C YN /M "WARNING: Do you wish to Continue? (This will make EFS BACKUP)"
IF ERRORLEVEL 2 GOTO MENU
@echo --- STARTING ----
@echo --- WAITING FOR DEVICE
bin\adb wait-for-device
@echo --- Backup efs image ---
bin\adb shell "echo | getprop > /sdcard/getprop.txt"
bin\adb pull /storage/sdcard0/getprop.txt
bin\adb shell "echo | getprop ril.product_code > /sdcard/version.txt ; getprop gsm.version.baseband >> /sdcard/version.txt ; getprop ril.serialnumber >> /sdcard/version.txt"
bin\adb pull /sdcard/version.txt
setlocal enabledelayedexpansion
for /f "tokens=*" %%a in (version.txt) do set "var=!var!%%a_"
echo %var%
bin\adb shell su -c "make_ext4fs -s -l 14M /sdcard/efs.img.ext4 /efs"
bin\adb shell su -c "dd if=dev/block/mmcblk0p11 of=/sdcard/%var%EFS.raw.img"
bin\adb shell su -c "busybox tar czvf /sdcard/%var%EFS.tar.gz /efs"
bin\adb pull /sdcard/efs.img.ext4
bin\adb pull /sdcard/%var%EFS.raw.img
bin\adb pull /sdcard/%var%EFS.tar.gz
bin\tar.exe -c efs.img.ext4 >> %var%EFS.tar
bin\md5sum.exe -t %var%EFS.tar >> %var%EFS.tar 2>nul
REN %var%EFS.tar %var%EFS.tar.md5
bin\7za.exe a %var%EFS.zip %var%EFS.tar.md5 %var%EFS.raw.img %var%EFS.tar.gz getprop.txt
del *.img *.ext4 *.txt *.gz *.md5
@echo -
@echo -
@echo Finished. Output file is %var%EFS BACKUP
) ELSE ( @echo "ERROR: PACKAGING does not exist" )
pause
goto MENU

:ODIN_RESTORE
CLS
@echo *****************************************
@echo *              ODIN RESTORE             *
@echo *****************************************
CHOICE /C YN /M "WARNING: Do you wish to Continue? (This will Restore EFS via Odin)"
IF ERRORLEVEL 2 GOTO MENU
bin\7za.exe e *.zip *.md5
bin\adb reboot download
@echo --- For restore, to chose flash file EFS.tar.md5 into slot PDA ---
cd bin
Odin3.exe
cd ..\
del *.md5
pause
goto MENU

:DD_RESTORE
CLS
@echo *****************************************
@echo *              DD RESTORE               *
@echo *****************************************
CHOICE /C YN /M "WARNING: Do you wish to Continue? (This will Restore EFS via command dd)"
IF ERRORLEVEL 2 GOTO MENU
bin\7za.exe e *.zip *EFS.raw.img
@echo --- STARTING ----
@echo --- WAITING FOR DEVICE
bin\adb wait-for-device
@echo --- Restore efs partition ---
bin\adb push *EFS.raw.img /sdcard/EFS.raw.img
bin\adb shell su -c "dd if=/sdcard/EFS.raw.img of=/dev/block/mmcblk0p11 bs=4096"
del *.img
pause
goto MENU

:TAR.GZ_RESTORE
CLS
@echo *****************************************
@echo *              TAR.GZ RESTORE           *
@echo *****************************************
CHOICE /C YN /M "WARNING: Do you wish to Continue? (This will Restore EFS from tar.gz archive)"
IF ERRORLEVEL 2 GOTO MENU
bin\7za.exe e *.zip *EFS.tar.gz
@echo --- STARTING ----
@echo --- WAITING FOR DEVICE
bin\adb wait-for-device
@echo --- Restore efs directory ---
bin\adb push *EFS.tar.gz /sdcard/EFS.tar.gz
bin\adb shell su -c "busybox tar zxvf /sdcard/EFS.tar.gz -C /"
del *.gz
pause
goto MENU

:EXIT
@echo Good-Bye
pause
exit
